var z = Object.defineProperty;
var A = (t, e, r) => e in t ? z(t, e, { enumerable: !0, configurable: !0, writable: !0, value: r }) : t[e] = r;
var p = (t, e, r) => (A(t, typeof e != "symbol" ? e + "" : e, r), r);
import G from "cac";
import a from "picocolors";
import C from "readline";
import { createLogger as _, createServer as J } from "vite";
import { loadConfig as Y } from "unconfig";
import $ from "fs";
import j, { resolve as L } from "path";
import "url";
import { resolve as V } from "pathe";
import W from "fast-glob";
import { parse as Q } from "acorn";
import X from "magic-string";
import { WebSocketServer as Z, WebSocket as ee } from "ws";
import { z as h } from "zod";
import { isMatch as te } from "micromatch";
import re from "chokidar";
import se from "events";
import F from "prompts";
const ne = "[viteburner]";
function ie(t = "", e = "", r = "") {
  const s = [];
  return t && s.push(a.green(t)), e && s.push(a.dim(e)), r && s.push(r), s.join(" ");
}
function oe(t) {
  return a.yellow(`${t}`);
}
function ae(t) {
  return a.red(`${t}`);
}
function ce() {
  const t = {
    base: _("info", { prefix: ne, allowClearScreen: !1 }),
    info: (...e) => t.base.info(ie(...e), { timestamp: !0, clear: !1 }),
    warn: (...e) => t.base.warn(oe(e.join(" ")), { timestamp: !0, clear: !1 }),
    error: (...e) => t.base.error(ae(e.join(" ")), { timestamp: !0, clear: !1 })
  };
  return t;
}
const i = ce();
function le(t) {
  process.stdin.isTTY || i.warn("current stdin is not a TTY. Keypress events may not work.");
  let e = !1;
  async function r(c, l) {
    (c === "" || c === "\x1B" || l && l.ctrl && l.name === "c") && (i.info("sigterm"), process.exit(1)), !e && (e = !0, await t({ str: c, key: l, on: n, off: o }), e = !1);
  }
  let s;
  function n() {
    o(), s = C.createInterface({ input: process.stdin }), C.emitKeypressEvents(process.stdin, s), process.stdin.isTTY && process.stdin.setRawMode(!0), process.stdin.on("keypress", r);
  }
  function o() {
    s == null || s.close(), s = void 0, process.stdin.off("keypress", r), process.stdin.isTTY && process.stdin.setRawMode(!1);
  }
  return n(), {
    on: n,
    off: o,
    running: () => e
  };
}
let x;
function H(t) {
  x = t;
}
le((t) => {
  x == null || x(t);
});
const fe = "viteburner", me = "0.3.0", ue = "Daemon tools of bitburner using vite for script transform, file syncing, RAM monitoring and more!", de = {
  viteburner: "bin/viteburner.js"
}, pe = "./dist/entry.js", he = "./dist/entry.mjs", ge = {
  ".": {
    require: "./dist/index.js",
    import: "./dist/index.mjs"
  }
}, we = "dist/typings/index.d.ts", ve = {
  build: "vite build",
  test: "npm run lint && npm run test:spec",
  "test:spec": "vitest run",
  "test:playground": "vite-node ./src/entry.ts -- --cwd ./playground",
  postversion: "npm run build",
  lint: "npm run lint:ts && npm run lint:eslint && npm run lint:prettier",
  "lint:ts": "tsc --noEmit",
  "lint:eslint": "eslint --ext .ts,.tsx,.js,.jsx .",
  "lint:prettier": 'prettier --check "**/*.{js,mjs,cjs,jsx,ts,mts,cts,tsx,json}"',
  format: 'prettier --write "**/*.{js,mjs,cjs,jsx,ts,mts,cts,tsx,json}"'
}, ye = {
  type: "git",
  url: "git+https://github.com/Tanimodori/viteburner.git"
}, be = [
  "bitburner",
  "vite"
], Se = "Tanimodori", $e = "MIT", Me = {
  url: "https://github.com/Tanimodori/viteburner/issues"
}, Re = "https://github.com/Tanimodori/viteburner#readme", Fe = {
  "@types/estree": "^1.0.0",
  "@types/micromatch": "^4.0.2",
  "@types/node": "^18.8.2",
  "@types/prompts": "^2.4.1",
  "@types/ws": "^8.5.3",
  "@typescript-eslint/eslint-plugin": "^5.39.0",
  "@typescript-eslint/parser": "^5.39.0",
  "builtin-modules": "^3.3.0",
  eslint: "^8.24.0",
  "eslint-config-prettier": "^8.5.0",
  "eslint-plugin-prettier": "^4.2.1",
  prettier: "^2.7.1",
  typescript: "^4.8.4",
  vite: "^3.1.8",
  "vite-node": "^0.24.0",
  "vite-plugin-dts": "^1.6.6",
  vitest: "^0.24.3"
}, je = {
  acorn: "^8.8.1",
  cac: "^6.7.14",
  chokidar: "^3.5.3",
  "fast-glob": "^3.2.12",
  "magic-string": "^0.26.7",
  micromatch: "^4.0.5",
  pathe: "^0.3.9",
  picocolors: "^1.0.0",
  prompts: "^2.4.2",
  unconfig: "^0.3.7",
  ws: "^8.9.0",
  zod: "^3.19.1"
}, xe = {
  vite: "^3.0.0"
}, q = {
  name: fe,
  version: me,
  description: ue,
  bin: de,
  main: pe,
  module: he,
  exports: ge,
  typings: we,
  scripts: ve,
  repository: ye,
  keywords: be,
  author: Se,
  license: $e,
  bugs: Me,
  homepage: Re,
  devDependencies: Fe,
  dependencies: je,
  peerDependencies: xe
};
function Ue(t) {
  return (e) => {
    const r = Ne(e);
    let s = t != null ? t : "home";
    if (typeof s == "function") {
      const n = s(e);
      if (!n)
        return [];
      s = n;
    }
    return Array.isArray(s) || (s = [s]), s.map((n) => {
      const o = {
        filename: r,
        server: "home",
        ...typeof n == "string" ? { server: n } : n
      };
      return o.filename = O(o.filename), o;
    });
  };
}
function De(t) {
  return typeof t == "string" ? t : t === !1 ? void 0 : "NetscriptDefinitions.d.ts";
}
function Ie(t) {
  return typeof t == "string" ? (e) => t + "/" + e : typeof t == "function" ? t : void 0;
}
function Te(t) {
  var n, o, c, l, m, g, w, v, S, M, f, u, d, y;
  const e = (n = t.watch) != null ? n : [], r = (c = (o = t.download) == null ? void 0 : o.server) != null ? c : "home";
  return {
    watch: e.map((b) => {
      var R;
      return {
        pattern: b.pattern,
        transform: (R = b.transform) != null ? R : !1,
        location: Ue(b.location)
      };
    }),
    sourcemap: (l = t.sourcemap) != null ? l : !1,
    port: (m = t.port) != null ? m : 12525,
    timeout: (g = t.timeout) != null ? g : 1e4,
    dts: De(t.dts),
    ignoreInitial: (w = t.ignoreInitial) != null ? w : !1,
    download: {
      server: Array.isArray(r) ? r : [r],
      location: (S = (v = t == null ? void 0 : t.download) == null ? void 0 : v.location) != null ? S : (b) => "src/" + b,
      ignoreTs: (f = (M = t == null ? void 0 : t.download) == null ? void 0 : M.ignoreTs) != null ? f : !0,
      ignoreSourcemap: (d = (u = t == null ? void 0 : t.download) == null ? void 0 : u.ignoreSourcemap) != null ? d : !0
    },
    dumpFiles: Ie(t.dumpFiles),
    cwd: (y = t.cwd) != null ? y : process.cwd()
  };
}
function St(t) {
  return t;
}
async function ke(t) {
  var r;
  const { config: e } = await Y({
    sources: [
      {
        files: "viteburner.config",
        extensions: ["ts", "mts", "cts", "js", "mjs", "cjs", "json", ""]
      },
      {
        files: "vite.config",
        async rewrite(s) {
          var c;
          const n = await (typeof s == "function" ? s() : s), o = (c = n == null ? void 0 : n.build) == null ? void 0 : c.sourcemap;
          return {
            ...o && { sourcemap: o },
            ...n == null ? void 0 : n.viteburner
          };
        }
      }
    ],
    cwd: (r = t.cwd) != null ? r : process.cwd(),
    merge: !0
  });
  return Te({
    ...e,
    ...t
  });
}
process.platform;
function U(t) {
  return t.replace(/\\/g, "/");
}
function Ee(t, e) {
  return e && t.startsWith(e) && (t = `/${t.slice(e.length)}`), t.replace(/^\/@id\/__x00__/, "\0").replace(/^\/@id\//, "").replace(/^__vite-browser-external:/, "").replace(/^(node|file):/, "").replace(/^\/+/, "/").replace(/\?v=\w+/, "?").replace(/&v=\w+/, "").replace(/\?t=\w+/, "?").replace(/&t=\w+/, "").replace(/\?import/, "?").replace(/&import/, "").replace(/\?&/, "?").replace(/\?+$/, "");
}
class Le {
  constructor(e, r = {}) {
    p(this, "items");
    p(this, "options");
    p(this, "watcher");
    p(this, "initial");
    p(this, "enabled");
    p(this, "enabledTimeStamp");
    p(this, "emitter");
    this.items = e, this.options = r, this.initial = !0, this.enabled = !0, this.enabledTimeStamp = 0, this.emitter = new se();
  }
  get patterns() {
    return this.items.map((e) => e.pattern);
  }
  findItem(e) {
    return this.items.find((r) => te(e, r.pattern));
  }
  init() {
    this.watcher = re.watch(this.patterns, this.options), this.watcher.on("ready", () => {
      this.initial = !1;
    });
    const e = ["add", "unlink", "change"];
    for (const r of e)
      this.watcher.on(r, (s) => {
        this.triggerHmr(s, r);
      });
  }
  triggerHmr(e, r) {
    var o;
    if (!this.enabled)
      return;
    const s = (o = this.options.cwd) != null ? o : process.cwd();
    if (r !== "unlink" && $.statSync(L(s, e)).mtimeMs <= this.enabledTimeStamp)
      return;
    const n = this.findItem(e);
    if (n)
      this.emitter.emit(B, {
        ...n,
        file: U(e),
        event: r,
        initial: this.initial,
        timestamp: Date.now()
      });
    else
      throw new Error(`File ${e} does not match any patterns`);
  }
  setEnabled(e) {
    this.enabled = e, e && (this.enabledTimeStamp = Date.now());
  }
  async fullReload() {
    var r;
    this.enabledTimeStamp = 0;
    const e = W.stream(this.patterns, { cwd: (r = this.options.cwd) != null ? r : process.cwd() });
    for await (const s of e)
      this.triggerHmr(s, "change");
  }
  getUploadFilenames(e) {
    e = D(U(e));
    const r = this.findItem(e);
    return r ? r.location(e) : [];
  }
  getUploadFilenamesByServer(e, r) {
    var n;
    return (n = this.getUploadFilenames(e).find((o) => o.server === r)) == null ? void 0 : n.filename;
  }
  close() {
    var e;
    (e = this.watcher) == null || e.close();
  }
}
function We(t) {
  if (!t)
    return "";
  const e = JSON.stringify(t);
  return `//# sourceMappingURL=data:application/json;base64,${Buffer.from(e).toString("base64")}`;
}
async function T(t, e) {
  const r = j.dirname(t);
  return $.existsSync(r) || await $.promises.mkdir(r, { recursive: !0 }), $.promises.writeFile(t, e, {
    flag: "w",
    encoding: "utf8"
  });
}
function K(t) {
  return t.endsWith(".js") || t.endsWith(".script");
}
const N = (t) => t.startsWith("/") ? t : "/" + t, O = (t) => {
  const e = t.lastIndexOf("/");
  return e === 0 ? t.substring(1) : e !== -1 ? N(t) : t;
}, D = (t) => t.startsWith("/") ? t.substring(1) : t, Ne = (t) => t.replace(/^src\//, "").replace(/\.ts$/, ".js");
function Ce() {
  i.info(
    "help",
    a.dim("press ") + a.reset(a.bold("h")) + a.dim(" to show help, press ") + a.reset(a.bold("q")) + a.dim(" to exit")
  );
}
function P() {
  i.info("vite", a.reset("watching for file changes...")), Ce();
}
function He(t) {
  const r = (f, u) => {
    i.info("status", a.reset(f.padStart(18)), u);
  }, s = () => {
    i.info("status"), i.info("status", " ".repeat(14) + a.reset(a.bold(a.inverse(a.green(" STATUS "))))), r("connection:", t.manager.connected ? a.green("connected") : a.yellow("disconnected")), r("port:", a.magenta(t.server.config.viteburner.port));
    const f = t.buffers.size, u = `${f} file${f === 1 ? "" : "s"}`, d = f ? a.yellow(u) : a.dim(u);
    r("pending:", d), i.info("status", a.dim(""));
  };
  s(), P();
  const n = () => {
    i.info("help");
    const f = [
      ["u", "upload all files"],
      ["d", "download all files"],
      ["s", "show status"],
      ["r", "show RAM usage of scripts"],
      ["q", "quit"]
    ];
    i.info("help", a.reset(a.bold("Watch Usage")));
    for (const [u, d] of f)
      i.info("help", `press ${a.reset(a.bold(u))}${a.dim(" to ")}${d}`);
    i.info("help", a.dim(""));
  }, o = () => t.manager.connected ? !0 : (i.error("conn", a.red("no connection")), !1), c = () => {
    i.info("upload", a.reset("force full-upload triggered")), t.server.watchManager.fullReload();
  }, l = () => {
    i.info("download", a.reset("force full-download triggered")), t.fullDownload();
  }, m = async () => (i.info("ram", a.reset("fetching ram usage of scripts...")), await t.getRamUsage(), !0), g = async () => {
    const { pattern: f } = await F({
      type: "text",
      name: "pattern",
      message: "Enter a glob pattern",
      initial: "src/**/*.{ts,js}"
    });
    return f ? (i.info("ram", a.reset("fetching ram usage of scripts...")), await t.getRamUsage(f), !0) : !1;
  }, w = async () => {
    const u = await W("**/*.{js,ts,script}", { cwd: t.server.config.root });
    u.sort();
    const d = /* @__PURE__ */ new Map();
    for (const b of u) {
      if (b.endsWith(".d.ts") || b === t.server.config.viteburner.dts)
        continue;
      const R = t.getRamUsageLocalData(b);
      R.length !== 0 && d.set(b, R);
    }
    const { file: y } = await F({
      type: "autocomplete",
      name: "file",
      message: "Enter a filename",
      choices: [...d.keys()].map((b) => ({ title: b }))
    });
    return y ? $.existsSync(L(t.server.config.root, y)) ? (d.has(y) ? await t.getRamUsageLocalRaw(y, d.get(y)) : await t.getRamUsageLocal(y), !0) : (i.error("ram", `file ${y} does not exist`), !1) : !1;
  }, v = async () => {
    const { server: f } = await F({
      type: "text",
      name: "server",
      message: "Enter a server name",
      initial: "home"
    });
    if (!f)
      return !1;
    const u = await t.getFileNames(f);
    if (!u)
      return !1;
    const { filename: d } = await F({
      type: "autocomplete",
      name: "filename",
      message: "Enter a filename",
      choices: u.filter(K).map((y) => ({ title: y }))
    });
    return d ? (await t.getRamUsageRemote(f, d), !0) : !1;
  }, S = async () => {
    const { filter: f } = await F({
      type: "select",
      name: "filter",
      message: "Which script do you want to check?",
      initial: 0,
      choices: [
        { title: "All local scripts", value: "all" },
        { title: "Filter local scripts by glob pattern", value: "glob" },
        { title: "Find a local script", value: "local" },
        { title: "Find a remote script", value: "remote" }
      ]
    });
    return f ? f === "all" ? m() : f === "glob" ? g() : f === "local" ? w() : f === "remote" ? v() : !1 : !1;
  }, M = async (f) => {
    f.off(), await S() ? i.info("ram", "done") : i.info("ram", "cancelled"), f.on();
  };
  return async (f) => {
    const { key: u } = f;
    let d = !0;
    u.name === "q" ? (i.info("bye"), process.exit()) : u.name === "s" ? s() : u.name === "h" ? n() : u.name === "u" ? o() && c() : u.name === "d" ? o() && l() : u.name === "r" ? o() && await M(f) : d = !1, d && P();
  };
}
function Pe(t) {
  return Q(t, {
    ecmaVersion: "latest",
    sourceType: "module",
    locations: !0
  });
}
function qe(t, e) {
  const r = e != null ? e : t.filename, s = t.manager.getUploadFilenamesByServer(r, t.server);
  if (s)
    return s;
  {
    const n = e ? `Path "${e}" imported by "${t.filename}" not found on server "${t.server}"` : `File "${e}" not found on server "${t.server}"`;
    return i.warn("import", n), i.warn("import", "This may be a problem when the script is running on the server."), r;
  }
}
function Ke(t) {
  const e = new X(t.content), r = Pe(t.content);
  for (const s of r.body)
    if (s.type === "ImportDeclaration") {
      const n = s.source, o = n.raw, c = n.value, l = N(qe(t, c)), m = o[0];
      e.overwrite(n.start, n.end, m + l + m);
    }
  return e.toString();
}
const k = (t, e, r) => {
  e = N(e);
  const s = `@${r}:${e}`;
  return {
    styled: `${a.dim(t)} ${a.reset("->")} ${a.dim(s)}`,
    raw: `${t} -> ${s}`
  };
}, Oe = (t, e, r) => {
  e = D(e);
  const s = `@${r}:/${t}`;
  return {
    styled: `${a.dim(s)} ${a.reset("->")} ${a.dim(e)}`,
    raw: `${s} -> ${e}`
  };
}, $t = (t) => "src/" + t, Mt = "NetscriptDefinitions.d.ts";
class Be {
  constructor(e, r) {
    p(this, "buffers", /* @__PURE__ */ new Map());
    p(this, "manager");
    p(this, "server");
    this.manager = e, this.server = r, this.manager.onConnected(async (s) => {
      i.info("conn", "", "connected"), s.on("close", () => {
        i.info("conn", "", a.yellow("disconnected"));
      }), await this.getDts(), await this.handleHmrMessage();
    });
  }
  async getDts() {
    const e = this.server.config.viteburner.dts;
    if (!!e)
      try {
        const r = await this.manager.getDefinitionFile(), s = this.server.config.root, n = j.resolve(s, e);
        await T(n, r), i.info("dts change", e);
      } catch (r) {
        i.error(`error getting dts file: ${r}`);
      }
  }
  async handleHmrMessage(e) {
    e ? Array.isArray(e) || (e = [e]) : e = [];
    const r = this.manager.connected;
    for (const s of e)
      s.transform && this.server.invalidateFile(s.file), this.buffers.set(s.file, s), i.info(`hmr ${s.event}`, s.file, a.yellow("(pending)"));
    if (!!r && this.buffers.size)
      for (const s of this.buffers.values())
        await this.uploadFile(s);
  }
  deleteCache(e) {
    const r = this.buffers.get(e.file);
    r && e.timestamp === r.timestamp && this.buffers.delete(e.file);
  }
  async dumpFile(e, r, s) {
    var c, l;
    const n = (l = (c = this.server.config.viteburner).dumpFiles) == null ? void 0 : l.call(c, e.file, s);
    if (!n)
      return;
    const o = j.resolve(this.server.config.root, n);
    await T(o, r), i.info("dump", k(e.file, U(n), s).styled);
  }
  async fetchModule(e) {
    let r = "";
    if (e.transform) {
      const s = await this.server.fetchModule(e.file);
      if (!s)
        throw new Error("module not found: " + e.file);
      r = s.code, this.server.config.viteburner.sourcemap === "inline" && s.map && (r += We(s.map));
    } else
      r = (await $.promises.readFile(j.resolve(this.server.config.root, e.file))).toString();
    return r;
  }
  fixImport(e, r, s) {
    return r.transform ? Ke({
      content: e,
      filename: r.file,
      server: s,
      manager: this.server.watchManager
    }) : e;
  }
  async uploadFile(e) {
    this.deleteCache(e);
    const r = e.event !== "unlink";
    let s = "";
    if (r)
      try {
        s = await this.fetchModule(e);
      } catch (o) {
        i.error(String(o));
        return;
      }
    const n = this.server.watchManager.getUploadFilenames(e.file);
    if (!n.length) {
      i.info(`hmr ${e.event}`, e.file, a.dim("(ignored)"));
      return;
    }
    for (const { filename: o, server: c } of n) {
      const l = k(e.file, o, c);
      try {
        r ? (e.transform && (s = this.fixImport(s, e, c)), this.dumpFile(e, s, c), await this.manager.pushFile({
          filename: o,
          content: s,
          server: c
        })) : await this.manager.deleteFile({
          filename: o,
          server: c
        }), i.info(`hmr ${e.event}`, l.styled, a.green("(done)"));
      } catch (m) {
        i.error(`error ${e.event}: ${l.raw} ${m}`), i.error(`hmr ${e.event} ${e.file} (error)`);
        continue;
      }
    }
  }
  async fullDownload() {
    i.info("vite", a.reset("stop watching for file changes while downloading")), this.server.watchManager.setEnabled(!1);
    const e = this.server.config.viteburner.download.server, r = /* @__PURE__ */ new Map();
    for (const s of e)
      try {
        r.set(s, await this.manager.getAllFiles({ server: s }));
      } catch (n) {
        i.error(`error: connot get filelist from server ${s}: ${n}`);
        continue;
      }
    for (const [s, n] of r) {
      const { location: o, ignoreTs: c, ignoreSourcemap: l } = this.server.config.viteburner.download;
      for (const m of n) {
        m.filename = D(m.filename);
        const g = o(m.filename, s);
        if (!g) {
          i.info("download", `@${s}:/${m.filename}`, a.dim("(ignored)"));
          continue;
        }
        const w = L(this.server.config.root, g), v = Oe(m.filename, g, s);
        try {
          const S = () => c && w.endsWith(".js") && $.existsSync(w.substring(0, w.length - 3) + ".ts"), M = () => l && m.content.match(/\/\/# sourceMappingURL=\S+\s*$/g);
          if (S() || M()) {
            i.info("download", v.styled, a.dim("(ignored)"));
            continue;
          }
          await T(w, m.content), i.info("download", v.styled, a.green("(done)"));
        } catch (S) {
          i.error("download", v.raw, `(${S})`);
        }
      }
    }
    i.info("vite", a.reset("download completed, watching for file changes...")), this.server.watchManager.setEnabled(!0);
  }
  async getRamUsage(e) {
    const r = e != null ? e : this.server.watchManager.patterns;
    if (!r) {
      i.warn("ram", "no pattern found");
      return;
    }
    const s = await W(r, { cwd: this.server.config.root });
    if (s.length === 0) {
      i.warn("ram", "no file found");
      return;
    }
    s.sort();
    for (const n of s)
      await this.getRamUsageLocal(n);
  }
  getRamUsageLocalData(e) {
    return this.server.watchManager.getUploadFilenames(e);
  }
  async getRamUsageLocalRaw(e, r) {
    let s = !1, n = -1;
    if (r.length === 0)
      return i.info("ram", `${e} (ignored)`), !0;
    for (const { filename: o, server: c } of r) {
      const l = k(e, o, c);
      if (!!K(o)) {
        s = !0;
        try {
          n = await this.manager.calculateRam({ filename: o, server: c }), i.info("ram", a.reset(`${e}: ${n} GB`));
          break;
        } catch (m) {
          i.warn("ram", l.raw, `(${m})`);
        }
      }
    }
    if (s) {
      if (n === -1)
        return i.warn("ram", e, "(no target found)"), !1;
    } else
      i.info("ram", e, a.dim("(ignored)"));
    return !0;
  }
  async getRamUsageLocal(e) {
    const r = this.getRamUsageLocalData(e);
    return this.getRamUsageLocalRaw(e, r);
  }
  async getRamUsageRemote(e, r) {
    const s = O(r);
    i.info("ram", a.reset("fetching ram usage of scripts..."));
    try {
      const n = await this.manager.calculateRam({ filename: s, server: e });
      i.info("ram", a.reset(`@${e}/${r}: ${n} GB`));
    } catch (n) {
      i.error("ram", `@${e}/${r}: ${n}`);
    }
  }
  async getFileNames(e) {
    try {
      return (await this.manager.getFileNames({ server: e })).map(D);
    } catch (r) {
      return i.error("list", `cannot fetch filenames from server ${e}: ${r}`), null;
    }
  }
}
const ze = h.object({
  jsonrpc: h.literal("2.0"),
  id: h.number(),
  result: h.any(),
  error: h.any()
}), Ae = h.literal("OK"), Ge = h.string(), _e = h.literal("OK"), Je = h.array(h.string()), Ye = h.array(
  h.object({
    filename: h.string(),
    content: h.string()
  })
), Ve = h.number(), Qe = h.string();
class Xe {
  constructor(e) {
    p(this, "options");
    p(this, "ws");
    p(this, "wss");
    p(this, "trackers");
    p(this, "nextId");
    this.options = {
      timeout: 1e4,
      ...e
    }, this.trackers = [], this.nextId = 0, this.ws = void 0, this.wss = new Z({ port: this.options.port }), this.wss.on("connection", (r) => {
      this.ws = r, r.on("message", (s) => this.handleMessage(s));
    }), this.wss.on("error", (r) => {
      const s = String(r);
      s.indexOf("EADDRINUSE") !== -1 ? (i.error("ws", `fatal: port ${this.options.port} is already in use`), process.exit(1)) : i.error("ws", `${s}`);
    });
  }
  get connected() {
    var e;
    return ((e = this.ws) == null ? void 0 : e.readyState) === ee.OPEN;
  }
  onConnected(e) {
    this.wss.on("connection", (r) => {
      this.ws = r, e(r);
    });
  }
  onDisconneted(e) {
    this.wss.on("close", e);
  }
  handleMessage(e) {
    const r = ze.parse(JSON.parse(e.toString())), { id: s, result: n, error: o } = r;
    if (!this.trackers[s])
      return;
    const { resolve: c, reject: l } = this.trackers[s];
    o && l(o), c(n);
  }
  async sendMessage(e) {
    const r = e.params;
    if (!this.ws || !this.connected)
      throw new Error("No connection");
    const s = ++this.nextId;
    this.ws.send(
      JSON.stringify({
        jsonrpc: "2.0",
        id: s,
        method: e.method,
        ...r && { params: r }
      })
    );
    const n = new Promise((o, c) => {
      const l = (g) => {
        var w, v;
        try {
          o((v = (w = e.validator) == null ? void 0 : w.parse(g)) != null ? v : g);
        } catch (S) {
          c(S);
        } finally {
          delete this.trackers[s];
        }
      }, m = (g) => {
        delete this.trackers[s], c(g);
      };
      this.trackers[s] = {
        resolve: l,
        reject: m
      };
    });
    return this.options.timeout && setTimeout(() => {
      this.trackers[s] && this.trackers[s].reject(new Error(`Timeout after ${this.options.timeout}ms`));
    }, this.options.timeout), n;
  }
  async pushFile(e) {
    return this.sendMessage({
      method: "pushFile",
      params: e,
      validator: Ae
    });
  }
  async getFile(e) {
    return this.sendMessage({
      method: "getFile",
      params: e,
      validator: Ge
    });
  }
  async deleteFile(e) {
    return this.sendMessage({
      method: "deleteFile",
      params: e,
      validator: _e
    });
  }
  async getFileNames(e) {
    return this.sendMessage({
      method: "getFileNames",
      params: e,
      validator: Je
    });
  }
  async getAllFiles(e) {
    return this.sendMessage({
      method: "getAllFiles",
      params: e,
      validator: Ye
    });
  }
  async calculateRam(e) {
    return this.sendMessage({
      method: "calculateRam",
      params: e,
      validator: Ve
    });
  }
  async getDefinitionFile() {
    return this.sendMessage({
      method: "getDefinitionFile",
      validator: Qe
    });
  }
  close() {
    var e;
    (e = this.ws) == null || e.close(), this.wss.close();
  }
}
const B = "viteburner:hmr", E = "virtual:viteburner-entry";
function Ze() {
  return {
    mode: "development",
    optimizeDeps: { disabled: !0 },
    clearScreen: !1,
    build: {
      lib: {
        entry: E,
        formats: ["es"]
      }
    },
    server: { middlewareMode: !0 }
  };
}
function et(t) {
  const e = "\0" + E;
  let r, s;
  return {
    name: "viteburner",
    async config(n) {
      return i.info("config", "resolving user config..."), n.viteburner = await ke(t), Ze();
    },
    configResolved() {
      i.info("config", "config resolved");
    },
    configureServer(n) {
      r = {
        ...n,
        pathToId(o) {
          const c = `/@fs/${U(V(r.config.root, o))}`;
          return Ee(c, r.config.base);
        },
        async invalidateFile(o) {
          const c = r.pathToId(o), l = await r.moduleGraph.getModuleByUrl(c);
          l && r.moduleGraph.invalidateModule(l);
        },
        async fetchModule(o) {
          const c = r.pathToId(o);
          return r.transformRequest(c);
        },
        onHmrMessage(o) {
          r.watchManager.emitter.on(B, (c) => o(c, r));
        },
        async buildStart() {
          return r.pluginContainer.buildStart({});
        }
      };
    },
    buildStart() {
      i.info("watch", "creating a watcher...");
      const { root: n, viteburner: o } = r.config, { watch: c, ignoreInitial: l, port: m, timeout: g } = o;
      r.watchManager = new Le(c, {
        cwd: n,
        persistent: !0,
        ignoreInitial: l
      }), i.info("ws", "creating ws server...");
      const w = new Xe({ port: m, timeout: g });
      s = new Be(w, r), r.onHmrMessage((v) => s.handleHmrMessage(v)), r.watchManager.init(), H(He(s));
    },
    resolveId(n) {
      if (n === E)
        return e;
    },
    load(n) {
      if (n === e)
        return "export {}";
    },
    buildEnd() {
      r.watchManager.close(), s.manager.close(), H();
    }
  };
}
const I = G("viteburner");
I.command("", "start dev server").alias("serve").alias("dev").option("--cwd <cwd>", "Working directory").option("--port <port>", "Port to listen on").action(tt);
I.help();
I.version(q.version);
async function tt(t) {
  const e = t.cwd, r = t.port, s = {
    ...e && { cwd: e },
    ...r && { port: r }
  };
  i.info("version", q.version), i.info("vite", "creating dev server..."), J({
    ...e && { root: e },
    viteburner: s,
    plugins: [et(s)]
  });
}
async function Rt() {
  I.parse();
}
export {
  Ne as A,
  Ce as B,
  P as C,
  He as D,
  k as E,
  Oe as F,
  $t as G,
  Mt as H,
  Be as I,
  Xe as J,
  ze as K,
  Ae as L,
  Ge as M,
  _e as N,
  Je as O,
  Ye as P,
  Ve as Q,
  Qe as R,
  Le as W,
  De as a,
  Ie as b,
  Te as c,
  St as d,
  oe as e,
  ie as f,
  ae as g,
  ce as h,
  i,
  H as j,
  B as k,
  ke as l,
  Rt as m,
  Ze as n,
  le as o,
  ne as p,
  et as q,
  Ue as r,
  tt as s,
  We as t,
  K as u,
  E as v,
  T as w,
  N as x,
  O as y,
  D as z
};
